#!/bin/sh
# Copyright Rene Mayrhofer, 2001
# modified by Peter Gastinger 2007
# This shell script is distributed under the terms of the GNU General Public License.
#
# generate DH Parameter and ServerKey for OpenVPN
#

DHPARAM=/etc/openvpn/dh1024.pem
KEYCONFIG=/etc/openvpn/openssl.cnf
KEYLENGTH=1024
DAYS=365
NAME=/etc/openvpn/server

countrycode="AT"
statename="Upper Austria"
localityname="Steyr"
orgname="Gibraltar"
orgunit="Gibraltar OpenVPN"
commonname="Gibraltar OpenVPN Server"
email="not specified"

if ! test -e $DHPARAM ; then
# Generating DH Parameters ...
  openssl dhparam -out $DHPARAM 1024
fi;

if ! test -e $NAME.key && ! test -e $NAME.crt
then
# genercate cert req
  echo -e "$countrycode\n$statename\n$localityname\n$orgname\n$orgunit\n$commonname\n$email\n\n\n" | \
  openssl req -days $DAYS -nodes -new -keyout $NAME.key -out $NAME.csr -extensions server -config $KEYCONFIG >/dev/null 2>&1
# sign req
  yes | openssl ca -days $DAYS -out $NAME.crt -in $NAME.csr -extensions server -config $KEYCONFIG >/dev/null 2>&1
  chmod 0600 $NAME.key
  chmod 0600 $NAME.crt
  rm $NAME.csr
fi;

# generate crl
#/usr/bin/openssl ca -gencrl -out /etc/ssl/crl.pem -config /etc/ssl/openssl.cnf

exit 0

