#!/usr/bin/perl

use strict;
use GDBM_File;
use Fcntl;
use Getopt::Std;

my %hash;
my %opts;
getopts('hf:u:sra:', \%opts); 
usage() if ($opts{'h'} || keys %opts != 3);

#  Open the file.
my $db = tie(%hash, 'GDBM_File', $opts{'f'}, O_RDWR, 0666) or die "Cannot open $opts{'f'}: $!\n";

if ($opts{'s'}) {
  print unpack('L',$hash{$opts{'u'}}), "\n";
}

if ($opts{'r'} && exists $hash{$opts{'u'}}) {
  $hash{$opts{'u'}}=pack('L',0);
  print unpack('L',$hash{$opts{'u'}}), "\n";
}
 
if ($opts{'a'} && exists $hash{$opts{'u'}}) {
  $hash{$opts{'u'}}=pack('L',$opts{'a'});
  print unpack('L',$hash{$opts{'u'}}), "\n";
}

undef $db;
untie %hash;

sub usage{
print << "EOF";
Usage: \t$0 -f filename -u username -s|-r|-a newvalue
-f filename: Filename of GDBM-Database
-u username: Username, e.g. peda
-s         : Show value
-r         : Reset value
-a newvalue: Sets value to newvalue
-h         : Show this help
EOF
exit;
}


