#  Copyright (C) 2002  Stanislav Sinyagin
#  Adapted by Rene Mayrhofer for the shell collector plugin
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.



# Use a Perl plugin module as the collector source

package Torrus::Collector::Shell;

use Torrus::ConfigTree;
use Torrus::Log;

use strict;

# Register the collector type
$Torrus::Collector::collectorTypes{'shell'} = 1;

###  Initialize the configuration validator with module-specific parameters

my %validatorLeafParams =
    (
     'shell-command'          => undef,
     
     );

sub initValidatorLeafParams
{
    my $hashref = shift;
    $hashref->{'ds-type'}{'collector'}{'collector-type'}{'shell'} =
        \%validatorLeafParams;
}


# List of needed parameters and default values

$Torrus::Collector::params{'shell'} = \%validatorLeafParams;

# expand our shell-command parameter
$Torrus::ConfigTree::expand_params{'shell-command'} = 1;

$Torrus::Collector::initTarget{'shell'} = \&Torrus::Collector::Shell::initTarget;

sub initTarget
{
    my $collector = shift;
    my $token = shift;

    # Nothing to do actually...

    return 1;
}


# This is first executed per target

$Torrus::Collector::runCollector{'shell'} =
    \&Torrus::Collector::Shell::runCollector;

sub runCollector
{
    my $collector = shift;
    my $cref = shift;

    my $now = time();

    foreach my $token ( $collector->listCollectorTargets('shell') )
    {
        my $script=$collector->param( $token, 'shell-command' );
        Debug('Executing script '.$script);
        #system("logger $script");
        
        my $value = `$script`;
        chomp $value;
        #system("logger $value");
        
        Debug("Setting value: $value for token: $token");
        $collector->setValue( $token, $value, $now );
    }
}


1;


# Local Variables:
# mode: perl
# indent-tabs-mode: nil
# perl-indent-level: 4
# End:
